/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Kamen Lisp.
 *
 * The Initial Developer of the Original Code is
 * Dustin Long (dlong@stevens.edu).
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var KamenLispConfig =
{
    start : function()
    {
    var sites = KamenLispPermissions.fetch();

    var whitelist = document.getElementById("whitelist");

    for (var i = 0; i < sites.length; i++)
    {
        var elem = document.createElement("listitem");

        var url = sites[i].domain + sites[i].path;

            elem.setAttribute("label", url);
            elem.setAttribute("crop", "end");
            whitelist.appendChild(elem);
    }

    whitelist.addEventListener("select", this.onListSelectionChanged, true);

    var defaultUrl = window.arguments[0].defaultUrl;
    if (defaultUrl)
    {
        var addSiteTxt = document.getElementById("add-site-txt");
        addSiteTxt.value = defaultUrl;
        var addSiteBtn = document.getElementById("add-site");
        addSiteBtn.disabled = false;
    }
    },

    finish: function()
    {
    var whitelist = document.getElementById("whitelist");
    var children = whitelist.childNodes;
    var allowed = new Array();
    for (var i = 0; i < children.length; i++)
    {
        allowed[i] = children[i].getAttribute("label");
    }
    KamenLispPermissions.update(allowed);
    window.close();
    },

    dismiss: function()
    {
    window.close();
    },

    onAddSiteInput: function(text)
    {
    var addSiteBtn = document.getElementById("add-site");
    addSiteBtn.disabled = (text.value == "");
    },

    onAddSiteClicked : function(btn)
    {
    if (!btn.disabled)
    {
        var addSiteText = document.getElementById("add-site-txt");
        var addSiteBtn = document.getElementById("add-site");
        var whitelist = document.getElementById("whitelist");

        var elem = document.createElement("listitem");

        var url = KamenLispPermissions.entry(addSiteText.value);
        if (url != "")
        {
        elem.setAttribute("label", url);
        elem.setAttribute("crop", "end");
        whitelist.appendChild(elem);

        addSiteText.value = "";
        addSiteBtn.disabled = true;
        }
    }
    },

    onListSelectionChanged : function()
    {
    var whitelist = document.getElementById("whitelist");
    var removeSiteBtn = document.getElementById("remove-site");
    var index = whitelist.selectedIndex;
    removeSiteBtn.disabled = (index == -1);
    },

    onRemoveSiteClicked : function(btn)
    {
    if (!btn.disabled)
    {
        var whitelist = document.getElementById("whitelist");
        var index = whitelist.selectedIndex;
        whitelist.removeItemAt(index);
    }
    }
}