
#ifndef _WIN32
#include <dlfcn.h>
#endif

typedef JSObject * (* JS_OX_fptr)(JSContext * );
typedef JSClass * (* JS_CO_fptr)(JSObject * );
typedef JSContext * (* JS_XRE_fptr)(JSRuntime * ,size_t );
typedef JSObject * (* JS_OXCOO_fptr)(JSContext * ,JSClass * ,JSObject * ,JSObject * );
typedef JSBool (* JS_BXOVW_fptr)(JSContext * ,JSObject * ,jsval ,jsval* );
typedef JSBool (* JS_BXO_fptr)(JSContext * ,JSObject * );
typedef JSBool (* JS_BXOV_fptr)(JSContext * ,JSObject * ,jsval );
typedef JSBool (* JS_BXOTW_fptr)(JSContext * ,JSObject * ,JSType ,jsval* );
typedef void (* JS_0XO_fptr)(JSContext * ,JSObject * );
typedef JSBool (* JS_BXOZW_fptr)(JSContext * ,JSObject * ,char* ,jsval* );
typedef JSIdArray * (* JS_AXO_fptr)(JSContext * ,JSObject * );
typedef void (* JS_0XA_fptr)(JSContext * ,JSIdArray * );
typedef JSBool (* JS_BXIW_fptr)(JSContext * ,jsid ,jsval* );
typedef JSBool (* JS_BXVS_fptr)(JSContext * ,jsval ,JSObject** );
typedef char* (* JS_ZS_fptr)(JSString * );
typedef void* (* JS_1XE_fptr)(JSContext * ,size_t );
typedef size_t (* JS_ES_fptr)(JSString * );
typedef JSBool (* JS_BXOZUWW_fptr)(JSContext * ,JSObject * ,char* ,uintN ,jsval* ,jsval* );
typedef JSString * (* JS_SXZE_fptr)(JSContext * ,char* ,size_t );

JS_OX_fptr m_GetGlobalObject_thunk = 0;
JS_OX_fptr m_GetScopeChain_thunk = 0;
JS_CO_fptr m_GetClass_thunk = 0;
JS_XRE_fptr m_NewContext_thunk = 0;
JS_OXCOO_fptr m_NewObject_thunk = 0;
JS_BXOVW_fptr m_PropertyStub_thunk = 0;
JS_BXO_fptr m_EnumerateStub_thunk = 0;
JS_BXOV_fptr m_ResolveStub_thunk = 0;
JS_BXOTW_fptr m_ConvertStub_thunk = 0;
JS_0XO_fptr m_FinalizeStub_thunk = 0;
JS_BXOZW_fptr m_SetProperty_thunk = 0;
JS_BXOZW_fptr m_GetProperty_thunk = 0;
JS_AXO_fptr m_Enumerate_thunk = 0;
JS_0XA_fptr m_DestroyIdArray_thunk = 0;
JS_BXIW_fptr m_IdToValue_thunk = 0;
JS_BXVS_fptr m_ValueToObject_thunk = 0;
JS_ZS_fptr m_GetStringBytes_thunk = 0;
JS_1XE_fptr m_malloc_thunk = 0;
JS_ES_fptr m_GetStringLength_thunk = 0;
JS_BXO_fptr m_ObjectIsFunction_thunk = 0;
JS_BXOZUWW_fptr m_CallFunctionName_thunk = 0;
JS_SXZE_fptr m_NewString_thunk = 0;

int JS_bridgeInit()
{
#ifdef _WIN32
    HMODULE hMod = ::LoadLibraryEx("js3250.dll", NULL, 0);
    if (!hMod) return 0;
    FARPROC targetProc;
#else
    void * hMod = dlopen("/usr/lib/firefox/libmozjs.so",RTLD_LAZY);
    if (!hMod) return 0;
    void * targetProc;
#endif

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_GetGlobalObject");
#else
    targetProc = dlsym(hMod, "JS_GetGlobalObject");
#endif
    if (!targetProc) return 0;
    m_GetGlobalObject_thunk = (JS_OX_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_GetScopeChain");
#else
    targetProc = dlsym(hMod, "JS_GetScopeChain");
#endif
    if (!targetProc) return 0;
    m_GetScopeChain_thunk = (JS_OX_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_GetClass");
#else
    targetProc = dlsym(hMod, "JS_GetClass");
#endif
    if (!targetProc) return 0;
    m_GetClass_thunk = (JS_CO_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_NewContext");
#else
    targetProc = dlsym(hMod, "JS_NewContext");
#endif
    if (!targetProc) return 0;
    m_NewContext_thunk = (JS_XRE_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_NewObject");
#else
    targetProc = dlsym(hMod, "JS_NewObject");
#endif
    if (!targetProc) return 0;
    m_NewObject_thunk = (JS_OXCOO_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_PropertyStub");
#else
    targetProc = dlsym(hMod, "JS_PropertyStub");
#endif
    if (!targetProc) return 0;
    m_PropertyStub_thunk = (JS_BXOVW_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_EnumerateStub");
#else
    targetProc = dlsym(hMod, "JS_EnumerateStub");
#endif
    if (!targetProc) return 0;
    m_EnumerateStub_thunk = (JS_BXO_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_ResolveStub");
#else
    targetProc = dlsym(hMod, "JS_ResolveStub");
#endif
    if (!targetProc) return 0;
    m_ResolveStub_thunk = (JS_BXOV_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_ConvertStub");
#else
    targetProc = dlsym(hMod, "JS_ConvertStub");
#endif
    if (!targetProc) return 0;
    m_ConvertStub_thunk = (JS_BXOTW_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_FinalizeStub");
#else
    targetProc = dlsym(hMod, "JS_FinalizeStub");
#endif
    if (!targetProc) return 0;
    m_FinalizeStub_thunk = (JS_0XO_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_SetProperty");
#else
    targetProc = dlsym(hMod, "JS_SetProperty");
#endif
    if (!targetProc) return 0;
    m_SetProperty_thunk = (JS_BXOZW_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_GetProperty");
#else
    targetProc = dlsym(hMod, "JS_GetProperty");
#endif
    if (!targetProc) return 0;
    m_GetProperty_thunk = (JS_BXOZW_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_Enumerate");
#else
    targetProc = dlsym(hMod, "JS_Enumerate");
#endif
    if (!targetProc) return 0;
    m_Enumerate_thunk = (JS_AXO_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_DestroyIdArray");
#else
    targetProc = dlsym(hMod, "JS_DestroyIdArray");
#endif
    if (!targetProc) return 0;
    m_DestroyIdArray_thunk = (JS_0XA_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_IdToValue");
#else
    targetProc = dlsym(hMod, "JS_IdToValue");
#endif
    if (!targetProc) return 0;
    m_IdToValue_thunk = (JS_BXIW_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_ValueToObject");
#else
    targetProc = dlsym(hMod, "JS_ValueToObject");
#endif
    if (!targetProc) return 0;
    m_ValueToObject_thunk = (JS_BXVS_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_GetStringBytes");
#else
    targetProc = dlsym(hMod, "JS_GetStringBytes");
#endif
    if (!targetProc) return 0;
    m_GetStringBytes_thunk = (JS_ZS_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_malloc");
#else
    targetProc = dlsym(hMod, "JS_malloc");
#endif
    if (!targetProc) return 0;
    m_malloc_thunk = (JS_1XE_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_GetStringLength");
#else
    targetProc = dlsym(hMod, "JS_GetStringLength");
#endif
    if (!targetProc) return 0;
    m_GetStringLength_thunk = (JS_ES_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_ObjectIsFunction");
#else
    targetProc = dlsym(hMod, "JS_ObjectIsFunction");
#endif
    if (!targetProc) return 0;
    m_ObjectIsFunction_thunk = (JS_BXO_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_CallFunctionName");
#else
    targetProc = dlsym(hMod, "JS_CallFunctionName");
#endif
    if (!targetProc) return 0;
    m_CallFunctionName_thunk = (JS_BXOZUWW_fptr)targetProc;

#ifdef _WIN32
    targetProc = ::GetProcAddress(hMod, "JS_NewString");
#else
    targetProc = dlsym(hMod, "JS_NewString");
#endif
    if (!targetProc) return 0;
    m_NewString_thunk = (JS_SXZE_fptr)targetProc;


#ifndef _WIN32
    dlclose(hMod);
#endif
    return 1;
}

JSObject * JS_bridge_GetGlobalObject(JSContext * a)
{
    return m_GetGlobalObject_thunk ? m_GetGlobalObject_thunk(a) : 0;
}

JSObject * JS_bridge_GetScopeChain(JSContext * a)
{
    return m_GetScopeChain_thunk ? m_GetScopeChain_thunk(a) : 0;
}

JSClass * JS_bridge_GetClass(JSObject * a)
{
    return m_GetClass_thunk ? m_GetClass_thunk(a) : 0;
}

JSContext * JS_bridge_NewContext(JSRuntime * a,size_t b)
{
    return m_NewContext_thunk ? m_NewContext_thunk(a,b) : 0;
}

JSObject * JS_bridge_NewObject(JSContext * a,JSClass * b,JSObject * c,JSObject * d)
{
    return m_NewObject_thunk ? m_NewObject_thunk(a,b,c,d) : 0;
}

JSBool JS_bridge_PropertyStub(JSContext * a,JSObject * b,jsval c,jsval* d)
{
    return m_PropertyStub_thunk ? m_PropertyStub_thunk(a,b,c,d) : 0;
}

JSBool JS_bridge_EnumerateStub(JSContext * a,JSObject * b)
{
    return m_EnumerateStub_thunk ? m_EnumerateStub_thunk(a,b) : 0;
}

JSBool JS_bridge_ResolveStub(JSContext * a,JSObject * b,jsval c)
{
    return m_ResolveStub_thunk ? m_ResolveStub_thunk(a,b,c) : 0;
}

JSBool JS_bridge_ConvertStub(JSContext * a,JSObject * b,JSType c,jsval* d)
{
    return m_ConvertStub_thunk ? m_ConvertStub_thunk(a,b,c,d) : 0;
}

void JS_bridge_FinalizeStub(JSContext * a,JSObject * b)
{
    if (m_FinalizeStub_thunk) m_FinalizeStub_thunk(a,b);
}

JSBool JS_bridge_SetProperty(JSContext * a,JSObject * b,char* c,jsval* d)
{
    return m_SetProperty_thunk ? m_SetProperty_thunk(a,b,c,d) : 0;
}

JSBool JS_bridge_GetProperty(JSContext * a,JSObject * b,char* c,jsval* d)
{
    return m_GetProperty_thunk ? m_GetProperty_thunk(a,b,c,d) : 0;
}

JSIdArray * JS_bridge_Enumerate(JSContext * a,JSObject * b)
{
    return m_Enumerate_thunk ? m_Enumerate_thunk(a,b) : 0;
}

void JS_bridge_DestroyIdArray(JSContext * a,JSIdArray * b)
{
    if (m_DestroyIdArray_thunk) m_DestroyIdArray_thunk(a,b);
}

JSBool JS_bridge_IdToValue(JSContext * a,jsid b,jsval* c)
{
    return m_IdToValue_thunk ? m_IdToValue_thunk(a,b,c) : 0;
}

JSBool JS_bridge_ValueToObject(JSContext * a,jsval b,JSObject** c)
{
    return m_ValueToObject_thunk ? m_ValueToObject_thunk(a,b,c) : 0;
}

char* JS_bridge_GetStringBytes(JSString * a)
{
    return m_GetStringBytes_thunk ? m_GetStringBytes_thunk(a) : 0;
}

void* JS_bridge_malloc(JSContext * a,size_t b)
{
    return m_malloc_thunk ? m_malloc_thunk(a,b) : 0;
}

size_t JS_bridge_GetStringLength(JSString * a)
{
    return m_GetStringLength_thunk ? m_GetStringLength_thunk(a) : 0;
}

JSBool JS_bridge_ObjectIsFunction(JSContext * a,JSObject * b)
{
    return m_ObjectIsFunction_thunk ? m_ObjectIsFunction_thunk(a,b) : 0;
}

JSBool JS_bridge_CallFunctionName(JSContext * a,JSObject * b,char* c,uintN d,jsval* e,jsval* f)
{
    return m_CallFunctionName_thunk ? m_CallFunctionName_thunk(a,b,c,d,e,f) : 0;
}

JSString * JS_bridge_NewString(JSContext * a,char* b,size_t c)
{
    return m_NewString_thunk ? m_NewString_thunk(a,b,c) : 0;
}

