/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Kamen Lisp.
 *
 * The Initial Developer of the Original Code is
 * Dustin Long (dlong@stevens.edu).
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var KamenLispShowMsg =
{
    // from browser/base/content/browser.js
    // undocumented and probably not forward compatible!

    _getBrowser: function (aDocShell)
    {
    var tabbrowser = getBrowser();
    for (var i = 0; i < tabbrowser.browsers.length; ++i) {
        var browser = tabbrowser.getBrowserAtIndex(i);
        if (this._findChildShell(browser.docShell, aDocShell))
        return browser;
    }
    return null;
    },
    
    _findChildShell: function (aDocShell, aSoughtShell)
    {
    if (aDocShell == aSoughtShell)
        return aDocShell;

    var node = aDocShell.QueryInterface(Components.interfaces.nsIDocShellTreeNode);
    for (var i = 0; i < node.childCount; ++i) {
        var docShell = node.getChildAt(i);
        docShell = this._findChildShell(docShell, aSoughtShell);
        if (docShell == aSoughtShell)
        return docShell;
    }
    return null;
    },
    
    display: function()
    {
        var webshell = Components.classes["@mozilla.org/webshell;1"].createInstance();
        var shell = webshell.QueryInterface(Components.interfaces.nsIDocShell);
        var browser = this._getBrowser(shell);

        var notificationName = "xpinstall";
    
    var doc = KamenLispUtils.getHtmlWindow();
    var url = doc.location;
    dump("at url [" + url + "]\n");

        buttons = [{
            label: "Edit permissions",
            accessKey: null,
            popup: null,
            callback: function() { KamenLispGlobal.config(url); }
        }];

        var notificationBox = gBrowser.getNotificationBox(browser);
        if (!notificationBox.getNotificationWithValue(notificationName)) {
            const priority = notificationBox.PRIORITY_WARNING_MEDIUM;
            const iconURL = "chrome://mozapps/skin/xpinstall/xpinstallItemGeneric.png";
            notificationBox.appendNotification("This site wants to run Common Lisp, which has no security checking. Allow this only if you completely trust the site.", notificationName,
                                               iconURL, priority, buttons);
        }

    }
};
